//+------------------------------------------------------------------+
//|                                            ADR_ ATR_20_Pairs.mq4 |
//|                                                        avoitenko |
//|                        https://login.mql5.com/en/users/avoitenko |
//+------------------------------------------------------------------+
#property copyright  ""
#property link       "https://login.mql5.com/en/users/avoitenko"

#property indicator_chart_window

#define LABEL_NAME "myLABLE_"
#define COUNT      20

int     ADR_PERIOD  =  20;
int     ATR_PERIOD  =  20;
//--- currency pairs
extern string  PAIR_01 = "AUDCAD";
extern string  PAIR_02 = "AUDJPY";
extern string  PAIR_03 = "AUDNZD";
extern string  PAIR_04 = "AUDUSD";
extern string  PAIR_05 = "CADJPY";
extern string  PAIR_06 = "CHFJPY";
extern string  PAIR_07 = "EURAUD";
extern string  PAIR_08 = "EURCAD";
extern string  PAIR_09 = "EURCHF";
extern string  PAIR_10 = "EURGBP";
extern string  PAIR_11 = "EURJPY";
extern string  PAIR_12 = "EURUSD";
extern string  PAIR_13 = "GBPCHF";
extern string  PAIR_14 = "GBPJPY";
extern string  PAIR_15 = "GBPUSD";
extern string  PAIR_16 = "NZDJPY";
extern string  PAIR_17 = "NZDUSD";
extern string  PAIR_18 = "USDCAD";
extern string  PAIR_19 = "USDCHF";
extern string  PAIR_20 = "USDJPY";
//---
extern int     PANEL_X     =  20;
extern int     PANEL_Y     =  60;
extern int     PANEL_CORNER=  0;
extern string  FONT_NAME   =  "Tahoma";
extern int     FONT_SIZE   =  11;
extern color   COLOR_PAIR  =  Green;
extern color   COLOR_TITLE =  CornflowerBlue;
extern color   COLOR_VALUE =  Gray;
extern color   COLOR_ADR_HIGHLIGHT = Orange;
extern int     ADR_LEVEL_HIGHLIGHT = 90;


string pairs[COUNT];
double array1[][6];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   
   pairs[0]  = PAIR_01;
   pairs[1]  = PAIR_02;
   pairs[2]  = PAIR_03;
   pairs[3]  = PAIR_04;
   pairs[4]  = PAIR_05;
   pairs[5]  = PAIR_06;
   pairs[6]  = PAIR_07;
   pairs[7]  = PAIR_08;
   pairs[8]  = PAIR_09;
   pairs[9]  = PAIR_10;
   pairs[10] = PAIR_11;
   pairs[11] = PAIR_12;
   pairs[12] = PAIR_13;
   pairs[13] = PAIR_14;
   pairs[14] = PAIR_15;
   pairs[15] = PAIR_16;
   pairs[16] = PAIR_17;
   pairs[17] = PAIR_18;
   pairs[18] = PAIR_19;
   pairs[19] = PAIR_20;

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   
   int total=ObjectsTotal();
   for(int i=total-1;i>=0;i--)
   {
      string obj_name = ObjectName(i);
      if(StringFind(obj_name, LABEL_NAME, 0) >= 0) ObjectDelete(obj_name);
   }
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
   
   
   //--- calc offset
   int max_len = 0;
   for(int i=0; i<COUNT; i++)
   {
      if(StringLen(pairs[i])>max_len) max_len = StringLen(pairs[i]);
   }
   max_len++;
   
   //--- set title
   string obj_name = LABEL_NAME + "title1";
   SetLabel(obj_name,"ADR",COLOR_TITLE, PANEL_X + FONT_SIZE*max_len, PANEL_Y);
   
   obj_name = LABEL_NAME + "title2";
   SetLabel(obj_name,"ATR",COLOR_TITLE, PANEL_X + FONT_SIZE*(max_len+5), PANEL_Y);
   
   int index = 0;
   double adr_value;
   double atr_value;
   for(i=0; i<COUNT; i++)
   {
      if(pairs[i] == "") continue;
      
      

      int digits = MarketInfo(pairs[i], MODE_DIGITS);
      double point = MarketInfo(pairs[i], MODE_POINT);

      if(digits==3 || digits==5) point=point*10;
      
      if(digits == 0)
      {
         string atr = "#";
         string adr = "#";
         adr_value = 0;
         atr_value = 0;
      }
      else
      {
         int bars = iBars(pairs[i],PERIOD_D1);
         //Print(i," ",pairs[i]," ",bars);
         if(bars < ATR_PERIOD)
         {
            ArrayCopyRates(array1,pairs[i],PERIOD_D1);
            atr = "load";
            adr = "load";
            adr_value = 0;
            atr_value = 0;
         }
         else
         {
            //atr = DoubleToStr(iATR(pairs[i], PERIOD_D1, ATR_PERIOD, 0)/point,0);
            
            atr_value = (iHigh(pairs[i], PERIOD_D1,0) - iLow(pairs[i], PERIOD_D1,0))/point;
            atr = DoubleToStr(atr_value,0);
            
            adr_value = DailyAverage(pairs[i],1);
            adr = DoubleToStr(adr_value,0);
         }
      } 
      
      
      
      
      color adr_color = COLOR_VALUE;
      color symbol_color = COLOR_PAIR;
      
      if(adr_value >= ADR_LEVEL_HIGHLIGHT)
      {
         adr_color = COLOR_ADR_HIGHLIGHT;
         symbol_color = COLOR_ADR_HIGHLIGHT;
      }
      
      //---      
      obj_name = LABEL_NAME + "ADR_" + pairs[i]+"_"+i;
      SetLabel(obj_name, adr, adr_color, PANEL_X + FONT_SIZE*max_len, PANEL_Y + (index +1)*FONT_SIZE*2);

      //---
      obj_name = LABEL_NAME + "ATR_" + pairs[i]+"_"+i;
      SetLabel(obj_name, atr, adr_color, PANEL_X + FONT_SIZE*(max_len+5), PANEL_Y + (index +1)*FONT_SIZE*2);
      
      //---      
      obj_name = LABEL_NAME + pairs[i]+" "+i;
      SetLabel(obj_name, pairs[i], symbol_color, PANEL_X, PANEL_Y + (index +1)*FONT_SIZE*2);

      index++;
   }

   return(0);
  }
//+------------------------------------------------------------------+
//|   SetLabel                                                       |
//+------------------------------------------------------------------+
void SetLabel(string obj_name, string tx, color cl, int xd, int yd)
{
   if(ObjectFind(obj_name)== 0|| ObjectCreate(obj_name, OBJ_LABEL, 0, 0, 0))
   {
      ObjectSet(obj_name, OBJPROP_COLOR    , cl);
      ObjectSet(obj_name, OBJPROP_XDISTANCE, xd);
      ObjectSet(obj_name, OBJPROP_YDISTANCE, yd);
      ObjectSet(obj_name, OBJPROP_CORNER   , PANEL_CORNER);
      ObjectSet(obj_name, OBJPROP_FONTSIZE , FONT_SIZE);
      ObjectSetText(obj_name, tx, FONT_SIZE, FONT_NAME);
   }
}
//+------------------------------------------------------------------+
//|   DailyAverage                                                   |
//+------------------------------------------------------------------+
double DailyAverage(string symbol,int bar)
{
   double val1;
   double val2;
   double val3;
   
   int tf = PERIOD_D1;
   double point = MarketInfo(symbol,MODE_POINT);
   double digits = MarketInfo(symbol,MODE_DIGITS);
   if(digits == 3 || digits == 5) point *= 10;
   
   double range = (iHigh(symbol, tf, bar) - iLow(symbol, tf, bar)) /point;

   for (int i=bar; i<=bar+4; i++) val1 += (iHigh(symbol, tf, i) - iLow(symbol, tf, i)) / point;
   val1 /= 5.0;
   
   for (i = bar; i <= bar + 9; i++) val2 += (iHigh(symbol, tf, i) - iLow(symbol, tf, i)) / point;
   val2 /= 10.0;
   
   for (i = bar; i <= bar + 19; i++) val3 += (iHigh(symbol, tf, i) - iLow(symbol, tf, i)) / point;
   val3 /= 20.0;
   
   double result = (range + val1 + val2 + val3) / 4.0;

   return (result);
}